#include <iostream>
#include <vector>
#include <math.h>

using namespace std;

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);

    int N, Q;
    cin >> N >> Q;
    vector<int> d;
    vector<int> p;
    vector<int> h;
    bool pNule = true;
    bool dNule = true;
    int a, b;
    int turns=0;
    for(int i=0; i<N; i++){
        cin >> a >> b;
        d.push_back(a);
        p.push_back(b);
    }
    for(int i=0; i<Q; i++)
    {
        cin >> a;
        h.push_back(a);
    }
    for(int i=0; i<N; i++){
        if(p[i]!=0)
            pNule=false;
        if(d[i]!=0)
            dNule=false;
    }
    int sum=0;
    vector<int> sums;
    if(pNule){
        for(int i=0;i<N;i++){
            sum+=d[i];
            sums.push_back(sum);
        }
        for(int i=0; i<Q; i++){
            if(h[i]>sum){
                cout <<"-1"<<endl;
                continue;
                }
            if(h[i] <= sum/2){
                for(int j=0; j<=N/2; j++){
                if(h[i]<=sums[j]){
                    cout << (j+1) << endl;
                    break;
                    }
                }
            }
            else{
                for(int j=N; j>N/2; j--){
                if(h[i]<=sums[j]){
                    cout << (j+1) << endl;
                    break;
                    }
                }
            }
            
        }
    }

    return 0;
}